U++ - Feature #939
Editorbar should dynamicaly change size depending on line numbers (linenumber ON)
11/27/2014 12:04 AM - Zbigniew Rebacz

Status: Approved Start date: 11/26/2014
Priority: Normal Due date:
Category: CodeEditor Estimated time: 0.00 hour
Target version: Spent time: 0.00 hour
Description

Dynamic size of bar when line numbering is on is great feature, because we can easily support more than 9999 lines without
unnecessarily wasting space. Of course our interface will be more scalable. Less lines = less bar size!

| have discovered that "EditorBar::SyncWidth()" should be implemented in following way:

void EditorBar::SyncWidth()
{
int digits = 0;
if (editor)
digits = IntStr(editor->GetLineCount()).GetLength(); // <- Needs synchronization!!! (See description below)

Width((line_numbers && editor ? editor->GetFont()['0"] * digits + 12 + 4 : 12 + 4) + annotations); // <- 4 is additional margin for

annotation.
Refresh();

The problem here is that SyncWidth should be invoking in different place in CodeEditor class for example putting new line or removing it
or on file load. This is hard because | don't know where the file is loaded to code editor. Should we ovverride "SetData" method?

- In this task linenumbering should handle 999 999 lines or even more. It is usefull for huge files.

History

#1 - 11/29/2014 01:11 AM - Zbigniew Rebacz
- Status changed from New to In Progress

- Assignee set to Zbigniew Rebacz

- % Done changed from 10 to 60

Almost done. Needs more test and checks and optimalization.

Progress:
- Editor bar now supprots up to one milion lines.
- Size of bar is dynamic and depends on number of lines.

#2 - 11/30/2014 01:38 AM - Zbigniew Rebacz

- File DynamicLineNumbers.diff added

- Status changed from In Progress to Patch ready

- Assignee changed from Zbigniew Rebacz to Miroslav Fidler
- % Done changed from 60 to 100
Implemented. Please check and review.

#3 - 12/07/2014 08:57 PM - Zbigniew Rebacz

- Status changed from Patch ready to In Progress

- Assignee changed from Miroslav Fidler to Zbigniew Rebacz
- % Done changed from 100 to 90

#4 - 12/07/2014 09:11 PM - Zbigniew Rebacz
- Status changed from In Progress to Patch ready

- Assignee changed from Zbigniew Rebacz to Miroslav Fidler
- % Done changed from 90 to 100

On clean build works well.

#5 - 12/27/2014 05:08 PM - Zbigniew Rebacz
- File DynamicLineNumbers.png added

Screenshot for preprocess file.

#6 - 01/06/2015 04:48 PM - Miroslav Fidler
- Status changed from Patch ready to Approved
- Assignee changed from Miroslav Fidler to Zbigniew Rebacz

#7 - 01/07/2015 11:56 PM - Zbigniew Rebacz
- File DynamicLineNumbers2.diff added

- Status changed from Approved to Patch ready
- Assignee changed from Zbigniew Rebacz to Miroslav Fidler

It cannot be approved ;), because it miss some of key features for example support for more than 10000 lines. Moreover in current implementation there is

a bug with break point annotation (it overlaps the line number).

12 + 4 in code means break point annotation (sorry for the magic number).

I include diff, please review and apply.

#8 - 01/09/2015 07:30 PM - Miroslav Fidler

- Status changed from Patch ready to Ready for QA
- Assignee changed from Miroslav Fidler to Zbigniew Rebacz

Sorry & thanks.

#9 - 01/10/2015 05:41 PM - Zbigniew Rebacz
- Status changed from Ready for QA to Approved
Files

DynamicLineNumbers.diff 4.05 KB 11/30/2014 Zbigniew Rebacz
DynamicLineNumbers.png 233 KB 12/27/2014 Zbigniew Rebacz
DynamicLineNumbers2.diff 1.01 KB 01/07/2015 Zbigniew Rebacz
